//////////////////////////////////////////////////////////////////////
//       SpeedStep Centrino © Gergely Rózsahegyi (RoGer) 2005       //
//                           roger@beos.hu                          //
//                                                                  //
//                       SeedStep Header File                       //
//                                                                  //
//                       Created:  2005.05.23                       //
//                                                                  //
//////////////////////////////////////////////////////////////////////

#ifndef __SPEEDSTEP_H__
#define __SPEEDSTEP_H__


#define SPEEDSTEP_HIGH  0x00000000
#define SPEEDSTEP_LOW   0x00000001

/* processors */

#define SPEEDSTEP_PROCESSOR_PIII_C_EARLY	0x00000001  /* Coppermine core */
#define SPEEDSTEP_PROCESSOR_PIII_C		0x00000002  /* Coppermine core */
#define SPEEDSTEP_PROCESSOR_PIII_T		0x00000003  /* Tualatin core */
#define SPEEDSTEP_PROCESSOR_P4M			0x00000004  /* P4-M  */

#define MSR_IA32_EBL_CR_POWERON         0x2a
#define MSR_IA32_PLATFORM_ID			0x17

/* For spinlocks etc */
#define local_irq_save(x)       __asm__ __volatile__("pushfl ; popl %0 ; cli":"=g" (x): /* no input */ :"memory")
#define local_irq_restore(x)    do { typecheck(unsigned long,x); __asm__ __volatile__("pushl %0 ; popfl": /* no output */ :"g" (x):"memory", "cc"); } while (0)

typedef struct {
	uint8	state;
	uint32	frequency;
} cpu_state;


static inline uint32 cpuid_ebx(uint32 op)
{
	uint32 eax, ebx;
	__asm__("cpuid"
			: "=a" (eax), "=b" (ebx)
			: "" (op)
			: "cx", "dx");
	return ebx;
};

#define rdmsr(msr,val1,val2) \
         __asm__ __volatile__("rdmsr" \
                           : "=a" (val1), "=d" (val2) \
                           : "c" (msr))
 
#endif
