#ifndef LAYOUT_H
#define LAYOUT_H

#include <View.h>
#include <Rect.h>
#include <List.h>


const int8 HORIZONTAL = 1;
const int8 VERTIKAL = 2;


typedef struct view_info
{
	BView *view;
	float weight;
	bool useownwidth;
};


void DivideSame(BList *list); //devide list of textcontrols


class Layout:public BView
{
	public:
		Layout(BRect rect, const char *name, uint32 resizingMode);
		~Layout();
		virtual void 	AttachedToWindow(void);
		virtual void FrameResized(float width, float height);
		
		void AddView(BView *view, float weight, bool useownwidth = false);
		void AddSpacer(float weight);
		void SetAlignment(int8 orientation);
	private:
		void CalculateViews();
		BList *fListOfViews;
		float fTotalWeight;
		bool fHorizontal;
		float fSpace;
};


#endif