#ifndef PREFWINDOW_H
#define PREFWINDOW_H

#include <View.h>
#include <Window.h>
#include <Messenger.h>
#include <RadioButton.h>
#include <TextControl.h>

#include "common.h"
#include "./layout/layout.h"

const uint PREF_EXITED = '&pre';
const uint CONTROL_CHANGE = '&auc';
const uint INTEGRATIONTIME_CHANGED = '&inc';
const uint THRESHOLD_CHANGED = '&trc';
const uint NEW_CONFIG = '&nco';


class PrefWindow : public BWindow
{
	public:
							PrefWindow(BRect rec, const char* title, 
										BMessenger *target, const FreqConfig* config);
							~PrefWindow();
			virtual	void	MessageReceived(BMessage *msg);
			virtual	bool	QuitRequested(void);	
					void	SetTarget(BHandler *handler);
					
	private:
			BMessenger 		*fMessenger;
			Layout			*fMainLayout;
			BRadioButton	*fAutoButton;
			BRadioButton	*fHighButton;
			BRadioButton	*fLowButton;
			BTextControl	*fIntegrationTimeControl;
			BTextControl	*fTresholdControl;
			FreqConfig		*fConfig;
			
};


#endif